// Michael J. Wilson
// Music 256a Fall 2010
// Homework #4

#ifndef __CLICK_GENERATOR_H__
#define __CLICK_GENERATOR_H__

#include <list>
#include <pthread.h>

class ClickGenerator
{
public:
    /// Destructor
    ~ClickGenerator();

    /// Constructor
    ClickGenerator();

    /// Lock the click generator.  Do this before modifying data.
    void lock();

    /// Unlock the click generator.
    void unlock();

    /// Schedule a new click cluster.  You should lock the generator first.
    void schedule_clicks(unsigned int num_clicks);

    /// Consume the next sample.  You should lock the generator first.
    float get_next_sample();

private:
    /// Current click tone
    float unit_click();

    /// Click clusters that are scheduled for the future
    std::list<unsigned int> m_scheduled_clicks;

    /// Remaining clicks before break, in samples
    unsigned int m_remaining_clicks;

    /// Remaining silence before looking for next click, in samples
    unsigned int m_remaining_silence;

    /// Mutex for locking
    pthread_mutex_t m_mutex;

    /// Sample record for bimodal sine wave generation
    unsigned int m_current_sample;
};

#endif
