// Michael J. Wilson
// Music 256a Fall 2010
// Homework #4

#include "Utility.h"
#include <cassert>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include "RtAudio.h"

// Static initializations
const float Utility::PI = std::atan(1.0)*4;
const float Utility::EPSILON = 0.0000001;
const unsigned int Utility::MAXIMUM_SAMPLE_RATE = 48000;
const std::string Utility::PROGRAM_NAME = "dolphins";
const unsigned int Utility::OUTPUT_CHANNELS = 2;
unsigned int Utility::sample_rate = 0;
RtAudio* dac = NULL;

Utility* Utility::get_utility()
{
    static Utility* instance = new Utility();
    return instance;
}

Utility::Utility()
{
    // Seed random number generator
    std::srand(std::time(NULL));
    dac = new RtAudio();
}

Utility::~Utility()
{
    delete dac;
}

float Utility::rand(float min, float max)
{
    return (min + ((max - min) * ((float)std::rand() / (float)RAND_MAX)));
}

float Utility::midi_to_frequency(int note)
{
    assert (note >=0);
    assert (note <=127);

    // Reference frequency is A440, note number 69
    const float fref=440;
    const int nref = 69;
    return (fref * std::pow(2,((float)note-(float)nref)/12.0));
}

int Utility::frequency_to_midi(float frequency)
{
    // Reference frequency is A440, note number 69
    const float fref=440;
    const int nref = 69;
    return std::floor(0.5 + ((float)nref + 12.0 * (std::log(frequency / fref) / std::log(2) )));
}

std::string Utility::midi_to_string(int note)
{
    std::string result;
    int pitch = note % 12;
    switch (pitch)
    {
    case 0:
        result = "C";
        break;
    case 1:
        result = "C#/Db";
        break;
    case 2:
        result = "D";
        break;
    case 3:
        result = "D#/Eb";
        break;
    case 4:
        result = "E";
        break;
    case 5:
        result = "F";
        break;
    case 6:
        result = "F#/Gb";
        break;
    case 7:
        result = "G";
        break;
    case 8:
        result = "G#/Ab";
        break;
    case 9:
        result = "A";
        break;
    case 10:
        result = "A#/Bb";
        break;
    case 11:
        result = "B";
        break;
    }
    return result;
}
